﻿@using System.Web.UI.WebControls;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.MVC;
@using Toyota.Common.Web.Html.Helper;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;

@using Portal.Models.Dock;
@using Portal.Models.MasterDataCompletenessCheck;
 
@model Toyota.Common.Web.MVC.ModelHolder          
           
@{    
    var mmActivityOption = TempData["MMActivity"] as string;
    var mmMatNoText = TempData["MMMatNo"] as string;
    var mmLastRunDate = TempData["MMLastRun"] as string;
    var mmProdMonthDate = TempData["MMProdMonth"] as string;
    var mmMatDescText = TempData["MMMatDesc"] as string;
    var mmCheckTimingDate = TempData["MMCheckTiming"] as string;
    var mmDockOption = TempData["MMDock"] as string;
    var tempData = TempData["MDCompData"] as List<MDCompletenessCheckData>;   
}

@using (Html.BeginForm("HandleForm", "MasterDataCompletenessCheck", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    <table  width="920px" cellpadding="2" cellspacing="2">
        <tr>
            <td align="left" style="width:120px">
                Activity <span style="color:Red;">*</span>
            </td>
            <td colspan="2">
                @Html.DevExpress().ComboBox(
                    settings =>
                    {
                        settings.Name = "MMActivityOption";
                        settings.Width = 180;
                        settings.Properties.DisplayFormatString = "{0}";
                        settings.Properties.ValueType = typeof(string);
                        settings.Properties.Items.Add("LPOP");
                        settings.Properties.Items.Add("GR");
                        if (!string.IsNullOrEmpty(mmActivityOption))
                        {
                            if (mmActivityOption.Equals("LPOP"))
                            {
                                settings.SelectedIndex = 0;
                            }
                            if (mmActivityOption.Equals("GR"))
                            {
                                settings.SelectedIndex = 1;
                            }
                        }
                        else
                        {
                            settings.SelectedIndex = 0;
                        }
                        
                    }
                ).GetHtml()
            </td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td align="left" style="width:120px">
                Material No
            </td>
            <td colspan="2">
                @Html.DevExpress().TextBox(
                    settings =>
                    {
                        settings.Name = "MMMatNoText";
                        settings.Width = 210;

                        if (!string.IsNullOrEmpty(mmMatNoText))
                            settings.Text = mmMatNoText;
                    }
                ).GetHtml()
            </td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td align="left" style="width:120px">
                @*Last Run*@
            </td>            
            <td colspan="2">            
                @Html.DevExpress().DateEdit(
                    dateEdit =>
                    {
                        dateEdit.Name = "MMLastRunDate";
                        dateEdit.ControlStyle.HorizontalAlign = HorizontalAlign.Left;
                        dateEdit.Properties.EditFormat = EditFormat.Custom;
                        dateEdit.Properties.EditFormatString = "dd.MM.yyyy";
                        dateEdit.Properties.DisplayFormatString = "dd.MM.yyyy";
                        dateEdit.Width = 180;
                        dateEdit.Properties.CalendarProperties.ShowClearButton = false;
                        dateEdit.Properties.CalendarProperties.ShowTodayButton = false;
                        //dateEdit.Properties.CalendarProperties.ShowHeader = false;    
                        dateEdit.Properties.CalendarProperties.EnableMonthNavigation = false;
                        dateEdit.Properties.CalendarProperties.EnableYearNavigation = false;
                        //dateEdit.Date = Convert.ToDateTime("12/03/1986"); 
                        dateEdit.ClientVisible = false;
                        if (!string.IsNullOrEmpty(mmLastRunDate))
                        {
                            //string[] prodMonth = mmProdMonthDate.Split('.').ToArray();
                            string[] prodMonth = mmLastRunDate.Split('.').ToArray();
                            dateEdit.Date = Convert.ToDateTime(prodMonth[1] + "/" + prodMonth[0] + "/" + prodMonth[2]);
                        }                        
                    }                                        
                ).GetHtml()
            </td>
        </tr>
        <tr>
            <td align="left" style="width:120px">
               Production Month <span style="color:Red;">*</span>
            </td>
            <td colspan="2">
                @Html.DevExpress().DateEdit(
                    settings =>
                    {
                        settings.Name = "MMProdMonthDate";
                        settings.ControlStyle.HorizontalAlign = HorizontalAlign.Left;
                        settings.Properties.EditFormat = EditFormat.Custom;
                        settings.Properties.DisplayFormatString = "MM.yyyy";
                        settings.Properties.EditFormatString = "MM.yyyy";
                        settings.Width = 180;                        
                        settings.Properties.ClientSideEvents.Init = @"
                        function OnInit(s, e) {
                            var calendar = s.GetCalendar();
                            calendar.owner = s;
                            calendar.SetVisible(false);                        
                        
                            MMLastRunDate.SetValue(MMProdMonthDate.GetValue());
                            MMCheckTimingDate.SetValue(MMProdMonthDate.GetValue());
                        }";
                        settings.Properties.ClientSideEvents.DateChanged = @"
                        function OnChanged(s,e) {
                           //alert(MMProdMonthDate.GetValue());

                           MMLastRunDate.SetValue(MMProdMonthDate.GetValue());
                           MMCheckTimingDate.SetValue(MMProdMonthDate.GetValue());     
                        }";
                        settings.Properties.ClientSideEvents.DropDown = @"
                        function OnDropDown(s, e) {
                            var calendar = s.GetCalendar();
                            var fastNav = calendar.fastNavigation;
                            fastNav.activeView = calendar.GetView(0, 0);
                            fastNav.Prepare();
                            fastNav.GetPopup().popupVerticalAlign = 'Below';
                            fastNav.GetPopup().ShowAtElement(s.GetMainElement())

                            fastNav.OnOkClick = function () {
                                //alert(MMProdMonthDate.GetValue());  

                                var parentDateEdit = this.calendar.owner;
                                var currentDate = new Date(fastNav.activeYear, fastNav.activeMonth, 1);
                                parentDateEdit.SetDate(currentDate);

                                MMLastRunDate.SetValue(MMProdMonthDate.GetValue());                            
                                MMCheckTimingDate.SetValue(MMProdMonthDate.GetValue());

                                parentDateEdit.HideDropDown();
                            }

                            fastNav.OnCancelClick = function () {
                                var parentDateEdit = this.calendar.owner;
                                parentDateEdit.HideDropDown();
                            }
                        
                        
                        }";
                        
                        if(!string.IsNullOrEmpty(mmProdMonthDate))
                        {
                            string[] prodMonth = mmProdMonthDate.Split('.').ToArray();
                            settings.Date = Convert.ToDateTime(prodMonth[0] + "/" + DateTime.Now.Day.ToString() + "/" + prodMonth[1]);
                        }
                        else
                        {
                         settings.Date = DateTime.Now;   
                        }
                    }
                ).GetHtml()
            </td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td align="left" style="width:120px">
                Material Desc
            </td>
            <td colspan="2">
                @Html.DevExpress().TextBox(
                    settings =>
                    {
                        settings.Name = "MMMatDescText";
                        settings.Width = 210;

                        if (!string.IsNullOrEmpty(mmMatDescText))
                            settings.Text = mmMatDescText;
                    }
                ).GetHtml()
            </td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            @*<td align="left" style="width:120px">
                Check Timing
            </td>*@
            <td colspan="2"> 
                @Html.DevExpress().DateEdit(
                    dateEdit =>
                    {
                        dateEdit.Name = "MMCheckTimingDate";
                        dateEdit.ControlStyle.HorizontalAlign = HorizontalAlign.Left;
                        dateEdit.Properties.EditFormat = EditFormat.Custom;
                        dateEdit.Properties.EditFormatString = "dd.MM.yyyy";
                        dateEdit.Properties.DisplayFormatString = "dd.MM.yyyy";
                        dateEdit.Width = 180;
                        dateEdit.Properties.CalendarProperties.ShowTodayButton = false;
                        dateEdit.Properties.CalendarProperties.ShowClearButton = false;
                        //dateEdit.Properties.CalendarProperties.ShowHeader = false;
                        dateEdit.Properties.CalendarProperties.EnableMonthNavigation = false;
                        dateEdit.Properties.CalendarProperties.EnableYearNavigation = false;
                        //dateEdit.Date = DateTime.Now;
                        dateEdit.ClientVisible = false;
                        if (!string.IsNullOrEmpty(mmCheckTimingDate))
                        {
                            //string[] prodMonth = mmProdMonthDate.Split('.').ToArray();
                            string[] prodMonth = mmCheckTimingDate.Split('.').ToArray();
                            dateEdit.Date = Convert.ToDateTime(prodMonth[1] + "/" + prodMonth[0] + "/" + prodMonth[2]);
                        }   
                    }
                ).GetHtml()
            </td>
        </tr>
        <tr>
            @*<td align="left" style="width:120px">
                Dock
            </td>*@
            <td colspan="2">            
                @Html.Common().DevExpress().GridLookup(
                    gridLookup =>
                    {
                        gridLookup.Name = "MMDockOption";
                        gridLookup.Width = 180;
                        gridLookup.GridProperties.KeyFieldName = "DOCK_CD";
                        gridLookup.GridProperties.CallbackRouteValues = new { Controller = "MasterDataCompletenessCheck", Action = "PartialMMDockOption" };
                        gridLookup.ReadOnly = true;
                        gridLookup.Visible = false;
                        gridLookup.GridProperties.Columns.Add(
                            col =>
                            {
                                col.Name = "PLANT_CD";
                                col.FieldName = "PLANT_CD";
                                col.Caption = "Plant <br/> Code";
                                col.Width = Unit.Pixel(50);
                                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            }
                            );
                        gridLookup.GridProperties.Columns.Add(
                            col =>
                            {
                                col.Name = "PLANT_NM";
                                col.FieldName = "PLANT_NM";
                                col.Caption = "Plant Name";
                                col.Width = Unit.Pixel(80);
                                col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            }
                            );
                        gridLookup.GridProperties.Columns.Add(
                            col =>
                            {
                                col.Name = "DOCK_CD";
                                col.FieldName = "DOCK_CD";
                                col.Caption = "Dock <br/> Code";
                                col.Width = Unit.Pixel(50);
                                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            }
                            );
                        gridLookup.GridProperties.Columns.Add(
                            col =>
                            {
                                col.Name = "DOCK_NM";
                                col.FieldName = "DOCK_NM";
                                col.Caption = "Dock Name";
                                col.Width = Unit.Pixel(200);
                                col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            }
                            );

                        if (!string.IsNullOrEmpty(mmDockOption))
                            gridLookup.Text = mmDockOption;
                    }
                 ).Bind(Model.GetModel<List<DockData>>()).GetHtml()       
            </td>
            <td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td colspan="2">&nbsp;</td><td></td>
            @*<td align="left" style="width:120px">
                Check By
            </td>*@
            <td colspan="2">
                @Html.DevExpress().TextBox(
                    settings =>
                    {
                        settings.Name = "MMCheckByText";
                        settings.Width = 180;
                        settings.ClientVisible = false;
                    }
                ).GetHtml()
            </td>
        </tr>  
        <tr> 
            <td colspan="12">
                <table width="100%" cellpadding="0" cellspacing="0">
                    <tr>
                        <td style="width:100px;">
                            @Html.DevExpress().Button(
                                settings =>
                                {
                                    settings.Name = "MMCheckButton";
                                    settings.Text = "Run Completeness Check";
                                    settings.UseSubmitBehavior = false;
                                    settings.Width = 160;
                                    //settings.ClientSideEvents.Click = "function(s, e){popupCompletenessCheck.Show();}";
                                    settings.ClientSideEvents.Click = "OnClickPerformMasterCompleteness";
                                }
                            ).GetHtml()
                        </td>
                        <td style="padding-left:10px">
                            @Html.DevExpress().Button(
                            settings => {
                                settings.Name = "BtnPerform";
                                settings.Text = "Perform Master Completeness Check";
                                settings.Width = 240;
                                settings.ClientSideEvents.Click =  "OnClickPerformMasterCompleteness";
                                settings.ClientVisible = false;
                            }).GetHtml()
                        </td>
                        <td style="display:inline-block;float:right;">
                            @Html.DevExpress().Button(
                                settings =>
                                {
                                    settings.Name = "MMClearButton";
                                    settings.Text = "Clear";
                                    settings.UseSubmitBehavior = false;
                                    settings.Width = 80;
                                    //settings.ClientSideEvents.Click = "function(s, e){ ASPxClientEdit.ClearEditorsInContainer(); }";
                                    settings.ClientSideEvents.Click = "MMClearButtonClick";                        
                                }
                            ).GetHtml()
                        </td>
                        <td style="display:inline-block;float:right; padding-right:10px"> 
                            @Html.DevExpress().Button(
                            settings =>
                                {
                                    settings.Name = "MMSearchButton";
                                    settings.Text = "Search";
                                    settings.UseSubmitBehavior = true;
                                    settings.Width = 80;
                                    settings.ClientSideEvents.Click = "MMSearchButtonClick";
                                }
                            ).GetHtml()
                        </td> 
                    </tr>
                </table> 
            </td>
        </tr>
    </table>
}